
#ifdef USE_SKIT

#include "skit.h"
#include "skit_error.h"


char   *skit_error_str[SKIT_MAX_ERROR+1];
int    skit_error_val[SKIT_MAX_ERROR+1];

/* *************************************************** */
/* return the number of the skit error identified by   */
/* the arguments value. .............................. */
/* *************************************************** */
int skit_error(int error) {
	int i;
	skit_error_str[0] = "UNKNOWN SKIT ERROR";

skit_error_str[1]="SKIT_INITIALIZE_OK";                                              skit_error_val[1]=0;
skit_error_str[2]="SKIT_KEYFILE_IO_ERROR";                                           skit_error_val[2]=1;
skit_error_str[3]="SKIT_KEYFILE_OPEN_FAILED";                                        skit_error_val[3]=2;
skit_error_str[4]="SKIT_KEYFILE_BAD_FORMAT";                                         skit_error_val[4]=3;
skit_error_str[5]="SKIT_KEYFILE_BAD_PASSWORD";                                       skit_error_val[5]=4;
skit_error_str[6]="SKIT_KEYFILE_BAD_MALLOC";                                         skit_error_val[6]=5;
skit_error_str[7]="SKIT_KEYFILE_NOTHING_TO_WRITE";                                   skit_error_val[7]=6;
skit_error_str[8]="SKIT_KEYFILE_WRITE_FAILED";                                       skit_error_val[8]=7;
skit_error_str[9]="SKIT_KEYFILE_NOT_FOUND";                                          skit_error_val[9]=8;
skit_error_str[10]="SKIT_KEYFILE_BAD_DNAME";                                         skit_error_val[10]=9;
skit_error_str[11]="SKIT_KEYFILE_BAD_KEY";                                           skit_error_val[11]=10;
skit_error_str[12]="SKIT_KEYFILE_KEY_EXISTS";                                        skit_error_val[12]=11;
skit_error_str[13]="SKIT_KEYFILE_BAD_LABEL";                                         skit_error_val[13]=12;
skit_error_str[14]="SKIT_KEYFILE_DUPLICATE_NAME";                                    skit_error_val[14]=13;
skit_error_str[15]="SKIT_KEYFILE_DUPLICATE_KEY";                                     skit_error_val[15]=14;
skit_error_str[16]="SKIT_KEYFILE_DUPLICATE_LABEL";                                   skit_error_val[16]=15;
skit_error_str[17]="SKIT_ERR_INIT_PARM_NOT_VALID";                                   skit_error_val[17]=100;
skit_error_str[18]="SKIT_INIT_HARD_RT";                                              skit_error_val[18]=101;
skit_error_str[19]="SKIT_INIT_SEC_TYPE_NOT_VALID";                                   skit_error_val[19]=102;
skit_error_str[20]="SKIT_INIT_V2_TIMEOUT_NOT_VALID";                                 skit_error_val[20]=103;
skit_error_str[21]="SKIT_INIT_V3_TIMEOUT_NOT_VALID";                                 skit_error_val[21]=104;
skit_error_str[22]="SKIT_KEYFILE_CERT_EXPIRED";                                      skit_error_val[22]=105;
skit_error_str[23]="SKIT_SOC_BAD_V2_CIPHER";                                         skit_error_val[23]=-40;
skit_error_str[24]="SKIT_SOC_BAD_V3_CIPHER";                                         skit_error_val[24]=-41;
skit_error_str[25]="SKIT_SOC_BAD_SEC_TYPE";                                          skit_error_val[25]=-42;
skit_error_str[26]="SKIT_SOC_BAD_SEC_TYPE_COMBINATION";                              skit_error_val[26]=-102;
skit_error_str[27]="SKIT_SOC_NO_READ_FUNCTION";                                      skit_error_val[27]=-43;
skit_error_str[28]="SKIT_SOC_NO_WRITE_FUNCTION";                                     skit_error_val[28]=-44;
skit_error_str[29]="SKIT_ERROR_NO_CIPHERS";                                          skit_error_val[29]=-1;
skit_error_str[30]="SKIT_ERROR_NO_CERTIFICATE";                                      skit_error_val[30]=-2;
skit_error_str[31]="SKIT_ERROR_BAD_CERTIFICATE";                                     skit_error_val[31]=-4;
skit_error_str[32]="SKIT_ERROR_UNSUPPORTED_CERTIFICATE_TYPE";                        skit_error_val[32]=-6;
skit_error_str[33]="SKIT_ERROR_IO";                                                  skit_error_val[33]=-10;
skit_error_str[34]="SKIT_ERROR_BAD_MESSAGE";                                         skit_error_val[34]=-11;
skit_error_str[35]="SKIT_ERROR_BAD_MAC";                                             skit_error_val[35]=-12;
skit_error_str[36]="SKIT_ERROR_UNSUPPORTED";                                         skit_error_val[36]=-13;
skit_error_str[37]="SKIT_ERROR_BAD_CERT_SIG";                                        skit_error_val[37]=-14;
skit_error_str[38]="SKIT_ERROR_BAD_CERT";                                            skit_error_val[38]=-15;
skit_error_str[39]="SKIT_ERROR_BAD_PEER";                                            skit_error_val[39]=-16;
skit_error_str[40]="SKIT_ERROR_PERMISSION_DENIED";                                   skit_error_val[40]=-17;
skit_error_str[41]="SKIT_ERROR_SELF_SIGNED";                                         skit_error_val[41]=-18;
skit_error_str[42]="SKIT_ERROR_BAD_MALLOC";                                          skit_error_val[42]=-20;
skit_error_str[43]="SKIT_ERROR_BAD_STATE";                                           skit_error_val[43]=-21;
skit_error_str[44]="SKIT_ERROR_SOCKET_CLOSED";                                       skit_error_val[44]=-22;
skit_error_str[45]="SKIT_ERROR_SKIT_INITIALIZATION_FAILED";                          skit_error_val[45]=-23;
skit_error_str[46]="SKIT_ERROR_HANDLE_CREATION_FAILED";                              skit_error_val[46]=-24;
skit_error_str[47]="SKIT_ERROR_BAD_KEY_LEN_FOR_EXPORT";                              skit_error_val[47]=-26;
skit_error_str[48]="SKIT_ERROR_UNKNOWN_ERROR";                                       skit_error_val[48]=-99;
skit_error_str[49]="SKIT_ERROR_BAD_BUFFER_SIZE";                                     skit_error_val[49]=-100;
skit_error_str[50]="SKIT_ERROR_BAD_SSL_HANDLE";                                      skit_error_val[50]=-101;
skit_error_str[51]="SKIT_ERROR_TIMEOUT";                                             skit_error_val[51]=-102;
skit_error_str[52]="SKIT_ERROR_NOT_SERVER";                                          skit_error_val[52]=-50;
skit_error_str[53]="SKIT_ERROR_NOT_SSLV3";                                           skit_error_val[53]=-51;
skit_error_str[54]="SKIT_ERROR_NOT_SSLV3_CLIENT";                                    skit_error_val[54]=-52;
skit_error_str[55]="SKIT_SECURE_SOC_RESET_OK";                                       skit_error_val[55]=0;
skit_error_str[56]="SSLV2_CLIENT_TIMEOUT";                                           skit_error_val[56]=100;
skit_error_str[57]="SSLV2_SERVER_TIMEOUT";                                           skit_error_val[57]=100;
skit_error_str[58]="SSLV3_CLIENT_TIMEOUT";                                           skit_error_val[58]=43200;
skit_error_str[59]="SSLV3_SERVER_TIMEOUT";                                           skit_error_val[59]=100;

	for (i=SKIT_MIN_ERROR;i<=SKIT_MAX_ERROR;i++) {
		if (skit_error_val[i] == error) return(i);
	}
	return(0);
}

#endif
